# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para jkanime
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------

import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

DEBUG = config.get_setting("debug")

__category__ = "A"
__type__ = "generic"
__title__ = "Personal"
__channel__ = "personal"
__language__ = "ES"
__creationdate__ = "20121022"

def isGeneric():
    return True

def mainlist(item):
    return personal_channel(item)

def personal_channel(item):
    logger.info("[personal.py] personal_channel "+item.channel)

    itemlist = []
    if item.url=="":
        if item.channel=="personal":
            item.url = config.get_setting("personalchannelurl")
        elif item.channel=="personal2":
            item.url = config.get_setting("personalchannelurl2")
        elif item.channel=="personal3":
            item.url = config.get_setting("personalchannelurl3")
        elif item.channel=="personal4":
            item.url = config.get_setting("personalchannelurl4")
        elif item.channel=="personal5":
            item.url = config.get_setting("personalchannelurl5")
    logger.info("url="+item.url)
    
    # Si es una URL la descarga
    if item.url.startswith("http://") or item.url.startswith("https://"):
        data = agrupa_datos( scrapertools.cache_page(item.url) )
    # Si es un fichero local, lo abre
    else:
        infile = open( item.url )
        data = infile.read()
        infile.close()
    
    # Paginación
    if item.extra=="":
        pagina_a_mostrar = 1
    else:
        pagina_a_mostrar = int(item.extra)

    #<item><title>Dragon Ball Z Resurrection &#039;F&#039; (2015) HDCam 72011perbersos.mkv</title><category>Movies</category><author>http://kat.cr/user/11perbersos/</author><link>http://kat.cr/dragon-ball-z-resurrection-f-2015-hdcam-72011perbersos-mkv-t10827497.html</link><guid>http://kat.cr/dragon-ball-z-resurrection-f-2015-hdcam-72011perbersos-mkv-t10827497.html</guid><pubDate>Sun, 21 Jun 2015 13:31:20 +0000</pubDate><torrent:contentLength>2715340417</torrent:contentLength><torrent:infoHash>32D2B429516B868EEF20F0F93A636B7BEF7EC331</torrent:infoHash><torrent:magnetURI><![CDATA[magnet:?xt=urn:btih:32D2B429516B868EEF20F0F93A636B7BEF7EC331&dn=dragon+ball+z+resurrection+f+2015+hdcam+72011perbersos+mkv&tr=udp%3A%2F%2Ftracker.publicbt.com%2Fannounce&tr=udp%3A%2F%2Fopen.demonii.com%3A1337]]></torrent:magnetURI><torrent:seeds>77</torrent:seeds><torrent:peers>116</torrent:peers><torrent:verified>0</torrent:verified><torrent:fileName>dragon.ball.z.resurrection.f.2015.hdcam.72011perbersos.mkv.torrent</torrent:fileName><enclosure url="http://torcache.net/torrent/32D2B429516B868EEF20F0F93A636B7BEF7EC331.torrent?title=[kat.cr]dragon.ball.z.resurrection.f.2015.hdcam.72011perbersos.mkv" length="2715340417" type="application/x-bittorrent" /></item>

    patron = '<item><title>([^<]+)</title><category>[^<]+</category><author>[^<]+</author><link>[^<]+</link><guid>[^<]+</guid><pubDate>[^<]+</pubDate><torrent:contentLength>[^<]+</torrent:contentLength><torrent:infoHash>[^<]+</torrent:infoHash><torrent:magnetURI><..CDATA.[^\]]+\].></torrent:magnetURI><torrent:seeds>[^<]+</torrent:seeds><torrent:peers>[^<]+</torrent:peers><torrent:verified>[^<]+</torrent:verified><torrent:fileName>[^<]+</torrent:fileName><enclosure url="([^?]+)?[^"]+" length="[^"]+" type="[^"]+" /></item>'

    matches = re.compile(patron,re.DOTALL).findall(data)    

    contador = 1
    pagina_actual = 1
    maximo = int(config.get_setting("personalchannelpage"))

    for scrapedtitle, scrapedurl in matches:

        # Si está en la página que debe mostrar añade los items
        if pagina_actual == pagina_a_mostrar:

            title = scrapedtitle.strip()
            url = scrapedurl

            itemlist.append( Item(channel=__channel__, action="play" , title=title, url=url, server="torrent", folder=False) )

            contador = contador + 1
            if contador > maximo:
                itemlist.append( Item(channel=__channel__, action="personal_channel" , title=">> Página siguiente" , extra=str(pagina_actual+1), folder=True))
                break

        # Si no está en la página que debe mostrar, simplemente deja pasar el contador
        else:
            contador = contador + 1
            if contador > maximo:
                pagina_actual = pagina_actual + 1
                contador = 1

    return itemlist
'''
def play(item):
    logger.info("[personal.py] play")
    itemlist = []

    itemlist.append( Item(channel=__channel__, action="play" , title=item.title, url=item.url, server="torrent", folder=False) )

    return itemlist
'''

def agrupa_datos(data):
    ## Agrupa los datos
    data = re.sub(r'\n|\r|\t|&nbsp;|<br>|<!--.*?-->','',data)
    data = re.sub(r'\s+',' ',data)
    data = re.sub(r'>\s<','><',data)
    return data

